]> arthur.barton.de Git - bup.git/blobdiff - cmd/split-cmd.py
Add author and committer arguments to new_commit()
[bup.git] / cmd / split-cmd.py
index 438fe40aaa73599938742d14fb77d77d1d522406..e813dd7d2658b4420ab21f9b9a7f4f78a7b9fc06 100755 (executable)
@@ -1,14 +1,24 @@
-#!/usr/bin/env python
-import sys, time
+#!/bin/sh
+"""": # -*-python-*-
+bup_python="$(dirname "$0")/bup-python" || exit $?
+exec "$bup_python" "$0" ${1+"$@"}
+"""
+# end of bup preamble
+
+import os, sys, time
+
 from bup import hashsplit, git, options, client
-from bup.helpers import *
+from bup.helpers import (handle_ctrl_c, hostname, log, parse_num, qprogress,
+                         reprogress, saved_errors, userfullname, username)
 
 
 optspec = """
-bup split <-t|-c|-b|-n name|--copy|--noop> [--bench] [filenames...]
+bup split [-t] [-c] [-n name] OPTIONS [--git-ids | filenames...]
+bup split -b OPTIONS [--git-ids | filenames...]
+bup split <--noop [--copy]|--copy>  OPTIONS [--git-ids | filenames...]
 --
  Modes:
-b,blobs    output a series of blob ids
+b,blobs    output a series of blob ids.  Implies --fanout=0.
 t,tree     output a tree id
 c,commit   output a commit id
 n,name=    save the result under the given name
@@ -24,7 +34,7 @@ keep-boundaries  don't let one chunk span two input files
 bench      print benchmark timings to stderr
 max-pack-size=  maximum bytes in a single pack
 max-pack-objects=  maximum number of objects in a single pack
-fanout=    maximum number of blobs in a single tree
+fanout=    average number of blobs in a single tree
 bwlimit=   maximum bytes/sec to transmit to server
 #,compress=  set compression level to # (0-9, 9 is highest) [1]
 """
@@ -35,10 +45,10 @@ handle_ctrl_c()
 git.check_repo_or_die()
 if not (opt.blobs or opt.tree or opt.commit or opt.name or
         opt.noop or opt.copy):
-    o.fatal("use one or more of -b, -t, -c, -n, -N, --copy")
-if (opt.noop or opt.copy) and (opt.blobs or opt.tree or 
+    o.fatal("use one or more of -b, -t, -c, -n, --noop, --copy")
+if (opt.noop or opt.copy) and (opt.blobs or opt.tree or
                                opt.commit or opt.name):
-    o.fatal('-N and --copy are incompatible with -b, -t, -c, -n')
+    o.fatal('--noop and --copy are incompatible with -b, -t, -c, -n')
 if opt.blobs and (opt.tree or opt.commit or opt.name):
     o.fatal('-b is incompatible with -t, -c, -n')
 if extra and opt.git_ids:
@@ -84,9 +94,9 @@ refname = opt.name and 'refs/heads/%s' % opt.name or None
 if opt.noop or opt.copy:
     cli = pack_writer = oldref = None
 elif opt.remote or is_reverse:
-    cli = client.Client(opt.remote, compression_level=opt.compress)
+    cli = client.Client(opt.remote)
     oldref = refname and cli.read_ref(refname) or None
-    pack_writer = cli.new_packwriter()
+    pack_writer = cli.new_packwriter(compression_level=opt.compress)
 else:
     cli = None
     oldref = refname and git.read_ref(refname) or None
@@ -106,7 +116,7 @@ if opt.git_ids:
         def __init__(self, it):
             self.it = iter(it)
         def read(self, size):
-            v = next(self.it)
+            v = next(self.it, None)
             return v or ''
     def read_ids():
         while 1:
@@ -117,8 +127,8 @@ if opt.git_ids:
                 line = line.strip()
             try:
                 it = cp.get(line.strip())
-                next(it)  # skip the file type
-            except KeyError, e:
+                next(it, None)  # skip the file type
+            except KeyError as e:
                 add_error('error: %s' % e)
                 continue
             yield IterToFile(it)
@@ -135,11 +145,19 @@ if pack_writer and opt.blobs:
         print sha.encode('hex')
         reprogress()
 elif pack_writer:  # tree or commit or name
-    shalist = hashsplit.split_to_shalist(pack_writer.new_blob,
-                                         pack_writer.new_tree,
-                                         files,
-                                         keep_boundaries=opt.keep_boundaries,
-                                         progress=prog)
+    if opt.name: # insert dummy_name which may be used as a restore target
+        mode, sha = \
+            hashsplit.split_to_blob_or_tree(pack_writer.new_blob,
+                                            pack_writer.new_tree,
+                                            files,
+                                            keep_boundaries=opt.keep_boundaries,
+                                            progress=prog)
+        splitfile_name = git.mangle_name('data', hashsplit.GIT_MODE_FILE, mode)
+        shalist = [(mode, splitfile_name, sha)]
+    else:
+        shalist = hashsplit.split_to_shalist(
+                      pack_writer.new_blob, pack_writer.new_tree, files,
+                      keep_boundaries=opt.keep_boundaries, progress=prog)
     tree = pack_writer.new_tree(shalist)
 else:
     last = 0
@@ -159,9 +177,11 @@ if opt.verbose:
 if opt.tree:
     print tree.encode('hex')
 if opt.commit or opt.name:
-    msg = 'bup split\n\nGenerated by command:\n%r' % sys.argv
+    msg = 'bup split\n\nGenerated by command:\n%r\n' % sys.argv
     ref = opt.name and ('refs/heads/%s' % opt.name) or None
-    commit = pack_writer.new_commit(oldref, tree, date, msg)
+    userline = '%s <%s@%s>' % (userfullname(), username(), hostname())
+    commit = pack_writer.new_commit(tree, oldref, userline, date, None,
+                                    userline, date, None, msg)
     if opt.commit:
         print commit.encode('hex')